<script lang="ts" setup>
import deliverystatus from '@/services/deliverystatus';
import { useDeliveryStore } from '@/stores/delivery';
import { useOrderStore } from '@/stores/order';
import { onMounted, ref, watch } from 'vue';
import { useDeliverystatusStore } from '@/stores/deliverystatus';

const deliveryStore = useDeliveryStore();
const orderStore = useOrderStore();
const deliverystatusStore = useDeliverystatusStore();
const backendURL = import.meta.env.VITE_BACKEND_URL;

function confirmStatus() {
  if (deliveryStore.editeddelivery) {
    deliveryStore.setDeliveryStatus(deliveryStore.editeddelivery?.deliverystatus?.id);
    console.log(selectedDeliveryStatus.value);
    deliveryStore.updateDelivery(deliveryStore.editeddelivery);
  }
  deliveryStore.dialog = false
}
onMounted(() => {
  deliveryStore.getDeliverys();
  deliverystatusStore.getdeliverystatus();
  console.log(deliveryStore.editeddelivery)
});
const selectedDeliveryStatus = ref('');
watch(() => deliveryStore.editeddelivery, (newValue) => {
  if (newValue && newValue.deliverystatus) {
    selectedDeliveryStatus.value = newValue.deliverystatus.name || '';
  }
});
</script>

<template>
  <v-dialog v-model="deliveryStore.dialog" persistent max-width="1500">
    <v-card height="900px">
      <v-row class="ma-5">
        <v-col cols="2"><span class="font">เลขคำสั่งซื้อ:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.id }}</v-col>
        <v-col cols="2"><span class="font">ที่อยู่:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.order?.address }}</v-col>
      </v-row>
      <v-row class="ma-5">
        <v-col cols="2"><span class="font">ชื่อผู้ซื้อ:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.user?.name }}</v-col>
        <v-col cols="2"><span class="font">เบอร์โทร:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.user?.telNumber }}</v-col>
      </v-row>
      <v-row class="ma-5">
        <v-col cols="2"><span class="font">สินค้า:</span>

        </v-col>
        <v-col> <template v-if="deliveryStore.editeddelivery?.order?.items">
            <ul>
              <li v-for="item in deliveryStore.editeddelivery.order.items" :key="item.id">{{ item.product.name }}</li>
            </ul>
          </template>
          <template v-else>ไม่พบข้อมูล</template></v-col>
        <v-col cols="2"><span class="font">รูปแบบการจัดส่ง:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.order?.deliveryMethod.name ?? 'ไม่พบข้อมูล' }}</v-col>
      </v-row>
      <v-row class="ma-5">
        <v-col cols="2"><span class="font">ยอดรวม:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.order?.totalPrice.toLocaleString() }} บาท</v-col>
        <!-- <v-col><span class="font">รูปแบบการชำระเงิน:</span> {{deliveryStore.editeddelivery?.order?.paymentMethod.name}}</v-col> -->
        <v-col cols="2"><span class="font">รูปแบบการชำระเงิน:</span> </v-col>
        <v-col>{{ deliveryStore.editeddelivery?.order?.paymentMethod.name ?? 'ไม่พบข้อมูล' }}</v-col>
      </v-row>
      <v-row class="ma-5">
        <v-col cols="2"><span class="font">ส่วนลด:</span></v-col>
        <v-col> {{ deliveryStore.editeddelivery?.order?.discount.toLocaleString() }} บาท</v-col>

        <v-col cols="2"> <span class="font">สถานะการจัดส่ง: </span>
        </v-col>
        <v-col
          v-for="item of deliveryStore.editeddelivery?.deliverystatus ? [deliveryStore.editeddelivery.deliverystatus] : []"
          :key="item.id">
          <!-- {{ deliveryStore.editeddelivery?.deliverystatus?.name }} -->
          <v-select v-model="item.name" :items="deliverystatusStore.deliverystatus.map(status => status.name)" outlined
            dense></v-select>
        </v-col>
      </v-row>
      <v-row class="ma-5">
        <v-col cols="6"></v-col>
        <v-col cols="2"><span class="font">หลักฐานการชำระเงิน:</span></v-col>
        <v-col><v-img :src="`${backendURL}/orders/image/${deliveryStore.editeddelivery?.order?.slipImage}`"
            height="200px"></v-img></v-col>
      </v-row>
      <v-row>
        <v-col cols="9"></v-col>
        <v-col><v-btn class="font" @click="deliveryStore.dialog = false">ย้อนกลับ</v-btn></v-col>
        <v-col><v-btn class="font" @click="confirmStatus">ยืนยัน</v-btn></v-col>
      </v-row>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.custom-text-field {
  width: 300px;
  height: 50px;
}

.fontTitle {
  text-align-last: center;
  font-family: fantasy;
  font-size: 35px;
  color: black;
}

.fontbtn {
  text-align-last: center;
  font-family: fantasy;
  font-size: 30px;
  color: black;
}

.font {
  text-align-last: center;
  font-family: fantasy;
  font-size: 20px;
  color: black;
}
</style>
